/*@ requires n >= 1 && \valid_read(a+(0..n-1));
    ensures (\result == -1 && (\forall integer i; 0 <= i < n ==> a[i] != z)) || (0 <= \result < n && a[\result] == z);
    // ensures 0 <= \result < n ==> a[\result] == z;
    assigns \nothing;
*/ 
int find (int* a, int n, int z) 
{ int m, i;
  
  m = -1;
  /*@
      loop invariant 0<= i <= n;
      loop invariant
        (m==-1 && (\forall integer k; 0 <= k < i ==> a[k]!=z)) || (0 <= m < n && a[m] == z);
      loop assigns i,m;
      loop variant n-i;
  */
  for (i=0; i<n; i++) 
    if (a[i] == z) {
      m = i; break;
    }
  return m; 
} 
